=== modified file 'src/matrix.h'
--- src/matrix.h	2011-01-25 15:00:12 +0000
+++ src/matrix.h	2011-01-25 15:06:04 +0000
@@ -19,8 +19,8 @@
  * Authors:
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _MATRIX_H
-#define _MATRIX_H
+#ifndef GLMARK2_MATRIX_H_
+#define GLMARK2_MATRIX_H_
 
 #include "oglsdl.h"
 

=== modified file 'src/mesh.h'
--- src/mesh.h	2011-01-25 15:00:12 +0000
+++ src/mesh.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _MESH_H
-#define _MESH_H
+#ifndef GLMARK2_MESH_H_
+#define GLMARK2_MESH_H_
 
 #include "screen.h"
 #include "vector.h"

=== modified file 'src/model.h'
--- src/model.h	2011-01-25 15:00:12 +0000
+++ src/model.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _MODEL_H
-#define _MODEL_H
+#ifndef GLMARK2_MODEL_H_
+#define GLMARK2_MODEL_H_
 
 #include "mesh.h"
 

=== modified file 'src/oglsdl.h'
--- src/oglsdl.h	2011-01-25 15:00:12 +0000
+++ src/oglsdl.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _OGLSDL_H
-#define _OGLSDL_H
+#ifndef GLMARK2_OGLSDL_H_
+#define GLMARK2_OGLSDL_H_
 
 #include <SDL/SDL.h>
 

=== modified file 'src/scene.h'
--- src/scene.h	2011-01-25 15:00:12 +0000
+++ src/scene.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _SCENE_H
-#define _SCENE_H
+#ifndef GLMARK2_SCENE_H_
+#define GLMARK2_SCENE_H_
 
 #include "oglsdl.h"
 

=== modified file 'src/screen-sdl-gl.h'
--- src/screen-sdl-gl.h	2011-01-25 15:00:12 +0000
+++ src/screen-sdl-gl.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _SCREEN_SDL_GL_H
-#define _SCREEN_SDL_GL_H
+#ifndef GLMARK2_SCREEN_SDL_GL_H_
+#define GLMARK2_SCREEN_SDL_GL_H_
 
 #include "screen-sdl.h"
 

=== modified file 'src/screen-sdl-glesv2.h'
--- src/screen-sdl-glesv2.h	2011-01-25 15:00:12 +0000
+++ src/screen-sdl-glesv2.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _SCREEN_SDL_GLESv2_H
-#define _SCREEN_SDL_GLESv2_H
+#ifndef GLMARK2_SCREEN_SDL_GLESv2_H_
+#define GLMARK2_SCREEN_SDL_GLESv2_H_
 
 #include "screen-sdl.h"
 

=== modified file 'src/screen-sdl.h'
--- src/screen-sdl.h	2011-01-25 15:00:12 +0000
+++ src/screen-sdl.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _SCREEN_SDL_H
-#define _SCREEN_SDL_H
+#ifndef GLMARK2_SCREEN_SDL_H_
+#define GLMARK2_SCREEN_SDL_H_
 
 #include "screen.h"
 

=== modified file 'src/screen.h'
--- src/screen.h	2011-01-25 15:00:12 +0000
+++ src/screen.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _SCREEN_H
-#define _SCREEN_H
+#ifndef GLMARK2_SCREEN_H_
+#define GLMARK2_SCREEN_H_
 
 #include "oglsdl.h"
 #include "matrix.h"

=== modified file 'src/shader.h'
--- src/shader.h	2011-01-25 15:00:12 +0000
+++ src/shader.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _SHADER_H
-#define _SHADER_H
+#ifndef GLMARK2_SHADER_H_
+#define GLMARK2_SHADER_H_
 
 #include "oglsdl.h"
 

=== modified file 'src/texture.h'
--- src/texture.h	2011-01-25 15:00:12 +0000
+++ src/texture.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _TEXTURE_H
-#define _TEXTURE_H
+#ifndef GLMARK2_TEXTURE_H_
+#define GLMARK2_TEXTURE_H_
 
 #include "oglsdl.h"
 

=== modified file 'src/vector.h'
--- src/vector.h	2011-01-25 15:00:12 +0000
+++ src/vector.h	2011-01-25 15:06:04 +0000
@@ -21,8 +21,8 @@
  *  Ben Smith (original glmark benchmark)
  *  Alexandros Frantzis (glmark2)
  */
-#ifndef _VECTOR_H
-#define _VECTOR_H
+#ifndef GLMARK2_VECTOR_H_
+#define GLMARK2_VECTOR_H_
 
 #include "oglsdl.h"
 