=== modified file 'src/mesh.cpp'
--- src/mesh.cpp	2011-11-09 10:14:02 +0000
+++ src/mesh.cpp	2011-11-16 10:07:47 +0000
@@ -79,12 +79,12 @@
 }
 
 
-/** 
+/**
  * Checks that an attribute is of the correct dimensionality.
  *
  * @param pos the position/index of the attribute to check
  * @param dim the size of the attribute (in #floats)
- * 
+ *
  * @return whether the check succeeded
  */
 bool
@@ -104,9 +104,9 @@
 }
 
 
-/** 
+/**
  * Ensures that we have a vertex to process.
- * 
+ *
  * @return the vertex to process
  */
 std::vector<float> &
@@ -237,7 +237,7 @@
     interleave_ = interleave;
 }
 
-/** 
+/**
  * Resets a Mesh object to its initial, empty state.
  */
 void
@@ -254,7 +254,7 @@
     vertex_stride_ = 0;
 }
 
-/** 
+/**
  * Builds a vertex array containing the mesh vertex data.
  *
  * The way the vertex array is constructed is affected by the current
@@ -309,7 +309,7 @@
     }
 }
 
-/** 
+/**
  * Builds a vertex buffer object containing the mesh vertex data.
  *
  * The way the VBO is constructed is affected by the current interleave
@@ -505,7 +505,7 @@
 }
 
 
-/** 
+/**
  * Deletes all resources associated with built vertex arrays.
  */
 void
@@ -518,7 +518,7 @@
     vertex_arrays_.clear();
 }
 
-/** 
+/**
  * Deletes all resources associated with built VBOs.
  */
 void
@@ -533,7 +533,7 @@
 }
 
 
-/** 
+/**
  * Renders a mesh using vertex arrays.
  *
  * The vertex arrays must have been previously initialized using
@@ -556,7 +556,7 @@
     }
 }
 
-/** 
+/**
  * Renders a mesh using vertex buffer objects.
  *
  * The vertex buffer objects must have been previously initialized using
@@ -580,9 +580,9 @@
     }
 }
 
-/** 
+/**
  * Creates a grid mesh.
- * 
+ *
  * @param n_x the number of grid cells on the X axis
  * @param n_y the number of grid cells on the Y axis
  * @param width the width X of the grid (normalized)

=== modified file 'src/mesh.h'
--- src/mesh.h	2011-11-09 10:14:02 +0000
+++ src/mesh.h	2011-11-16 10:07:47 +0000
@@ -29,7 +29,7 @@
 #include "vec.h"
 #include "gl-headers.h"
 
-/** 
+/**
  * A mesh of vertices.
  */
 class Mesh

=== modified file 'src/model.cpp'
--- src/model.cpp	2011-11-11 14:38:08 +0000
+++ src/model.cpp	2011-11-16 10:07:47 +0000
@@ -48,9 +48,9 @@
     } \
 } while(0);
 
-/** 
+/**
  * Computes the bounding box for a Model::Object.
- * 
+ *
  * @param object the Model object
  */
 void
@@ -94,9 +94,9 @@
     minVec_ = vec3(minX, minY, minZ);
 }
 
-/** 
+/**
  * Appends the vertices of a Model::Object to a Mesh.
- * 
+ *
  * @param object the object to append
  * @param mesh the mesh to append to
  * @param p_pos the attribute position to use for the 'position' attribute
@@ -155,11 +155,11 @@
     }
 }
 
-/** 
+/**
  * Converts a model to a mesh using the default attributes bindings.
  *
  * The default attributes and their order is: Position, Normal, Texcoord
- * 
+ *
  * @param mesh the mesh to populate
  */
 void
@@ -174,7 +174,7 @@
     convert_to_mesh(mesh, attribs);
 }
 
-/** 
+/**
  * Converts a model to a mesh using custom attribute bindings.
  *
  * The attribute bindings are pairs of <AttribType, dimensionality>.
@@ -222,7 +222,7 @@
     }
 }
 
-/** 
+/**
  * Calculates the normal vectors of the model vertices.
  */
 void
@@ -294,11 +294,11 @@
     }
 }
 
-/** 
+/**
  * Load a model from a 3DS file.
- * 
+ *
  * @param filename the name of the file
- * 
+ *
  * @return whether loading succeeded
  */
 bool
@@ -471,9 +471,9 @@
     return true;
 }
 
-/** 
+/**
  * Parse vec3 values from an OBJ file.
- * 
+ *
  * @param source the source line to parse
  * @param v the vec3 to populate
  */
@@ -528,9 +528,9 @@
     v.z(z);
 }
 
-/** 
+/**
  * Parse uvec3 values from an OBJ file.
- * 
+ *
  * @param source the source line to parse
  * @param v the uvec3 to populate
  */
@@ -585,11 +585,11 @@
     v.z(z);
 }
 
-/** 
+/**
  * Load a model from an OBJ file.
- * 
+ *
  * @param filename the name of the file
- * 
+ *
  * @return whether loading succeeded
  */
 bool
@@ -671,13 +671,13 @@
 ModelMap modelMap;
 }
 
-/** 
+/**
  * Locate all available models.
  *
  * This method scans the built-in data paths and build a database of usable
  * models available to scenes.  Map is available on a read-only basis to scenes
  * that might find it useful for listing models, etc.
- * 
+ *
  * @return a map containing information about the located models
  */
 const ModelMap&
@@ -738,14 +738,14 @@
     return ModelPrivate::modelMap;
 }
 
-/** 
+/**
  * Load a model by name.
  *
  * You must initialize the available model collection using
  * Model::find_models() before using this method.
- * 
+ *
  * @param modelName the model name
- * 
+ *
  * @return whether the operation succeeded
  */
 bool

=== modified file 'src/model.h'
--- src/model.h	2011-11-11 14:38:08 +0000
+++ src/model.h	2011-11-16 10:07:47 +0000
@@ -39,7 +39,7 @@
     MODEL_OBJ
 };
 
-/** 
+/**
  * A descriptor for a model file.
  */
 class ModelDescriptor
@@ -61,7 +61,7 @@
 
 typedef std::map<std::string, ModelDescriptor*> ModelMap;
 
-/** 
+/**
  * A model as loaded from a 3D object data file.
  */
 class Model